// Paq32.dll
// $Id: Paq32.h,v 1.4 2006/03/20 09:57:58 sirakaba Exp $

#ifndef PAQ32_H
#define PAQ32_H

//******************************************************************************
//    萔`
//******************************************************************************

// APIړ
#define API_PREFIX				Paq
#define API_NAME(api_suffix)	Paq##api_suffix

// 萔`
#ifndef FNAME_MAX32
#define FNAME_MAX32 512
#endif

#ifndef ARC_DECSTRACT
#define ARC_DECSTRACT

//******************************************************************************
//    \̒`
//******************************************************************************

#pragma pack(1)

// EnumMenberProc
typedef BOOL(CALLBACK * PAQ_WND_ENUMMEMBPROC)(LPVOID _lpInfo);

typedef struct PAQ_ENUM_MEMBER_INFO
{
	DWORD dwStructSize;
	UINT uCommand;
	DWORD dwOriginalSize;
	DWORD dwCompressedSize;
	DWORD dwAttributes;
	DWORD dwCRC;
	UINT uOSType;
	WORD wRatio;
	FILETIME ftCreateTime;
	FILETIME ftAccessTime;
	FILETIME ftWriteTime;
	char szFileName[FNAME_MAX32 + 1];
	char dummy1[3];
	char szAddFileName[FNAME_MAX32 + 1];
	char dummy2[3];
}	PAQ_ENUM_MEMBER_INFO, * LPPAQ_ENUM_MEMBER_INFO;

typedef struct PAQ_ENUM_MEMBER_INFO64
{
	DWORD dwStructSize;
	UINT uCommand;
	UINT64 llOriginalSize;
	UINT64 llCompressedSize;
	DWORD dwAttributes;
	DWORD dwCRC;
	UINT uOSType;
	WORD wRatio;
	FILETIME ftCreateTime;
	FILETIME ftAccessTime;
	FILETIME ftWriteTime;
	char szFileName[FNAME_MAX32 + 1];
	char dummy1[3];
	char szAddFileName[FNAME_MAX32 + 1];
	char dummy2[3];
}	PAQ_ENUM_MEMBER_INFO64, * LPPAQ_ENUM_MEMBER_INFO64;

// OwnerWindow
typedef BOOL(CALLBACK * ARCHIVERPROC)(HWND _hwnd, UINT _uMsg, UINT _nState, LPVOID _lpEis);
typedef ARCHIVERPROC * LPARCHIVERPROC;

typedef struct EXTRACTINGINFO
{
	DWORD dwFileSize;
	DWORD dwWriteSize;
	char szSourceFileName[FNAME_MAX32 + 1];
	char dummy1[3];
	char szDestFileName[FNAME_MAX32 + 1];
	char dummy[3];
}	EXTRACTINGINFO, * LPEXTRACTINGINFO;

typedef struct EXTRACTINGINFOEX
{
	EXTRACTINGINFO exinfo;
	DWORD dwCompressedSize;
	DWORD dwCRC;
	UINT uOSType;
	WORD wRatio;
	WORD wDate;
	WORD wTime;
	char szAttribute[8];
	char szMode[8];
}	EXTRACTINGINFOEX, * LPEXTRACTINGINFOEX;

typedef struct EXTRACTINGINFOEX32
{
	DWORD dwStructSize;
	EXTRACTINGINFO exinfo;
	DWORD dwFileSize;
	DWORD dwCompressedSize;
	DWORD dwWriteSize;
	DWORD dwAttributes;
	DWORD dwCRC;
	UINT uOSType;
	WORD wRatio;
	FILETIME ftCreateTime;
	FILETIME ftAccessTime;
	FILETIME ftWriteTime;
	char szMode[8];
	char szSourceFileName[FNAME_MAX32 + 1];
	char dummy1[3];
	char szDestFileName[FNAME_MAX32 + 1];
	char dummy2[3];
}	EXTRACTINGINFOEX32, * LPEXTRACTINGINFOEX32;

typedef struct EXTRACTINGINFOEX64
{
	DWORD dwStructSize;
	EXTRACTINGINFO exinfo;
	UINT64 llFileSize;
	UINT64 llCompressedSize;
	UINT64 llWriteSize;
	DWORD dwAttributes;
	DWORD dwCRC;
	UINT uOSType;
	WORD wRatio;
	FILETIME ftCreateTime;
	FILETIME ftAccessTime;
	FILETIME ftWriteTime;
	char szMode[8];
	char szSourceFileName[FNAME_MAX32 + 1];
	char dummy1[3];
	char szDestFileName[FNAME_MAX32 + 1];
	char dummy2[3];
}	EXTRACTINGINFOEX64, * LPEXTRACTINGINFOEX64;

// OpenArchive
typedef	HGLOBAL	HARC;

typedef struct INDIVIDUALINFO
{
	DWORD dwOriginalSize;
 	DWORD dwCompressedSize;
	DWORD dwCRC;
	UINT uFlag;
	UINT uOSType;
	WORD wRatio;
	WORD wDate;
	WORD wTime;
	char szFileName[FNAME_MAX32 + 1];
	char dummy1[3];
	char szAttribute[8];
	char szMode[8];
}	INDIVIDUALINFO, * LPINDIVIDUALINFO;

#pragma pack()

#endif

//******************************************************************************
//    萔`(API)
//******************************************************************************

// i󋵃R[h
#ifndef WM_ARCEXTRACT
#define	WM_ARCEXTRACT			"wm_arcextract"
#define	ARCEXTRACT_BEGIN		0
#define	ARCEXTRACT_INPROCESS	1
#define	ARCEXTRACT_END			2
#define ARCEXTRACT_OPEN			3
#define ARCEXTRACT_COPY			4
#endif

// `FbN[h
#ifndef CHECKARCHIVE_RAPID
#define CHECKARCHIVE_RAPID		0
#define	CHECKARCHIVE_BASIC		1
#define	CHECKARCHIVE_FULLCRC	2
#define CHECKARCHIVE_RECOVERY	4
#define CHECKARCHIVE_SFX		8
#define CHECKARCHIVE_ALL		16
#define CHECKARCHIVE_ENDDATA	32
#endif

// xR[h
#ifndef ERROR_START
#define ERROR_START				0x8000
#define ERROR_DISK_SPACE		0x8005
#define ERROR_READ_ONLY			0x8006
#define ERROR_USER_SKIP			0x8007
#define ERROR_UNKNOWN_TYPE		0x8008
#define ERROR_METHOD			0x8009
#define ERROR_PASSWORD_FILE		0x800A
#define ERROR_VERSION			0x800B
#define ERROR_FILE_CRC			0x800C
#define ERROR_FILE_OPEN			0x800D
#define ERROR_MORE_FRESH		0x800E
#define ERROR_NOT_EXIST			0x800F
#define ERROR_ALREADY_EXIST		0x8010
#define ERROR_TOO_MANY_FILES	0x8011
// G[R[h
#define ERROR_MAKEDIRECTORY		0x8012
#define ERROR_CANNOT_WRITE		0x8013
#define ERROR_HUFFMAN_CODE		0x8014
#define ERROR_COMMENT_HEADER	0x8015
#define ERROR_HEADER_CRC		0x8016
#define ERROR_HEADER_BROKEN		0x8017
#define ERROR_ARC_FILE_OPEN		0x8018
#define ERROR_NOT_ARC_FILE		0x8019
#define ERROR_CANNOT_READ		0x801A
#define ERROR_FILE_STYLE		0x801B
#define ERROR_COMMAND_NAME		0x801C
#define ERROR_MORE_HEAP_MEMORY	0x801D
#define ERROR_ENOUGH_MEMORY		0x801E
#define ERROR_ALREADY_RUNNING	0x801F
#define ERROR_USER_CANCEL		0x8020
#define ERROR_HARC_ISNOT_OPENED	0x8021
#define ERROR_NOT_SEARCH_MODE	0x8022
#define ERROR_NOT_SUPPORT		0x8023
#define ERROR_TIME_STAMP		0x8024
#define ERROR_TMP_OPEN			0x8025
#define ERROR_LONG_FILE_NAME	0x8026
#define ERROR_ARC_READ_ONLY		0x8027
#define ERROR_SAME_NAME_FILE	0x8028
#define ERROR_NOT_FIND_ARC_FILE	0x8029
#define ERROR_RESPONSE_READ		0x802A
#define ERROR_NOT_FILENAME		0x802B
#define ERROR_TMP_COPY			0x802C
#define ERROR_EOF				0x802D
#define ERROR_ADD_TO_LARC		0x802E
#define ERROR_TMP_BACK_SPACE    0x802F
#define ERROR_SHARING			0x8030
#define ERROR_NOT_FIND_FILE		0x8031
#define ERROR_LOG_FILE			0x8032
#define	ERROR_NO_DEVICE			0x8033
#define ERROR_GET_ATTRIBUTES    0x8034
#define ERROR_SET_ATTRIBUTES	0x8035
#define ERROR_GET_INFORMATION   0x8036
#define ERROR_GET_POINT			0x8037
#define ERROR_SET_POINT			0x8038
#define ERROR_CONVERT_TIME		0x8039
#define ERROR_GET_TIME			0x803A
#define ERROR_SET_TIME			0x803B
#define ERROR_CLOSE_FILE		0x803C
#define ERROR_HEAP_MEMORY		0x803D
#define ERROR_HANDLE			0x803E
#define ERROR_TIME_STAMP_RANGE  0x803F
#define ERROR_MAKE_ARCHIVE		0x8040
#define ERROR_NOT_CONFIRM_NAME	0x8041
#define ERROR_UNEXPECTED_EOF	0x8042
#define ERROR_INVALID_END_MARK	0x8043
#define ERROR_INVOLVED_LZH		0x8044
#define ERROR_NO_END_MARK		0x8045
#define ERROR_HDR_INVALID_SIZE	0x8046
#define ERROR_UNKNOWN_LEVEL		0x8047
#define ERROR_BROKEN_DATA		0x8048
#define ERROR_INVALID_PATH		0x8049
#define ERROR_TOO_BIG			0x804A
#define ERROR_EXECUTABLE_FILE	0x804B
#define ERROR_END				ERROR_EXECUTABLE_FILE
#endif

// ֐R[h
#ifndef ISARC_FUNCTION_START
#define ISARC_FUNCTION_START			0
#define ISARC							0
#define ISARC_GET_VERSION				1
#define ISARC_GET_CURSOR_INTERVAL		2
#define ISARC_SET_CURSOR_INTERVAL		3
#define ISARC_GET_BACK_GROUND_MODE		4
#define ISARC_SET_BACK_GROUND_MODE		5
#define ISARC_GET_CURSOR_MODE			6
#define ISARC_SET_CURSOR_MODE			7
#define ISARC_GET_RUNNING				8

#define ISARC_CHECK_ARCHIVE				16
#define ISARC_CONFIG_DIALOG				17
#define ISARC_GET_FILE_COUNT			18
#define ISARC_QUERY_FUNCTION_LIST		19

#define ISARC_HOUT						20
#define ISARC_STRUCTOUT					21
#define ISARC_GET_ARC_FILE_INFO			22
#define ISARC_OPEN_ARCHIVE				23
#define ISARC_CLOSE_ARCHIVE				24
#define ISARC_FIND_FIRST				25
#define ISARC_FIND_NEXT					26
#define ISARC_EXTRACT					27
#define ISARC_ADD						28
#define ISARC_MOVE						29
#define ISARC_DELETE					30

#define ISARC_SETOWNERWINDOW			31
#define ISARC_CLEAROWNERWINDOW			32
#define ISARC_SETOWNERWINDOWEX			33
#define ISARC_KILLOWNERWINDOWEX			34

#define ISARC_GET_ARC_FILE_NAME			40
#define ISARC_GET_ARC_FILE_SIZE			41
#define ISARC_GET_ARC_ORIGINAL_SIZE		42
#define ISARC_GET_ARC_COMPRESSED_SIZE	43
#define ISARC_GET_ARC_RATIO				44
#define ISARC_GET_ARC_DATE				45
#define ISARC_GET_ARC_TIME				46
#define ISARC_GET_ARC_OS_TYPE			47
#define ISARC_GET_ARC_IS_SFX_FILE		48
#define ISARC_GET_ARC_WRITE_TIME_EX		49
#define ISARC_GET_ARC_CREATE_TIME_EX	50
#define	ISARC_GET_ARC_ACCESS_TIME_EX	51
#define	ISARC_GET_ARC_CREATE_TIME_EX2	52
#define ISARC_GET_ARC_WRITE_TIME_EX2	53

#define ISARC_GET_FILE_NAME				57
#define ISARC_GET_ORIGINAL_SIZE			58
#define ISARC_GET_COMPRESSED_SIZE		59
#define ISARC_GET_RATIO					60
#define ISARC_GET_DATE					61
#define ISARC_GET_TIME					62
#define ISARC_GET_CRC					63
#define ISARC_GET_ATTRIBUTE				64
#define ISARC_GET_OS_TYPE				65
#define ISARC_GET_METHOD				66
#define ISARC_GET_WRITE_TIME			67
#define ISARC_GET_CREATE_TIME			68
#define ISARC_GET_ACCESS_TIME			69
#define ISARC_GET_WRITE_TIME_EX			70
#define ISARC_GET_CREATE_TIME_EX		71
#define ISARC_GET_ACCESS_TIME_EX		72

#define ISARC_SET_ENUM_MEMBERS_PROC		80
#define ISARC_CLEAR_ENUM_MEMBERS_PROC	81

#define ISARC_GET_ARC_FILE_SIZE_EX		82
#define ISARC_GET_ARC_ORIGINAL_SIZE_EX	83
#define ISARC_GET_ARC_COMPRESSED_SIZE_EX 84

#define ISARC_GET_ORIGINAL_SIZE_EX		85
#define ISARC_GET_COMPRESSED_SIZE_EX	86

#define ISARC_SETOWNERWINDOWEX64		87
#define ISARC_KILLOWNERWINDOWEX64		88
#define ISARC_SET_ENUM_MEMBERS_PROC64	89
#define ISARC_CLEAR_ENUM_MEMBERS_PROC64	90

#define ISARC_OPEN_ARCHIVE2				91

#define ISARC_GET_ARC_READ_SIZE			92
#define ISARC_GET_ARC_READ_SIZE_EX		93

#define SET_LANGUE_JAPANESE				94
#define SET_LANGUE_ENGLISH				95
#define SET_LANGUE_SPECIFIED			96
#define ISARC_SET_LANGUE_SPECIFIED		97
#define ISARC_SET_LANGUE_JAPANESE		98
#define ISARC_SET_LANGUE_ENGLISH		99

#define ISARC_SET_PRIORITY				100

#define ISARC_FUNCTION_END				ISARC_SET_PRIORITY
#endif

// spXۃ[h
#ifndef BPL_NORMAL
#define BPL_NORMAL					0
#define BPL_DENY_TOO_MANY_PARENTS	1
#define BPL_DENY_ABS_PATH			2
#define BPL_DENY_PARENTS			4
#define BPL_DENY_EXECUTABLE			8
#define BPL_DENY_LEVEL_0			0
#define BPL_DENY_LEVEL_1			1
#define BPL_DENY_LEVEL_2			3
#define BPL_DENY_LEVEL_3			7
#endif

// nh擾[h
#ifndef EXTRACT_FOUND_FILE
#define M_INIT_FILE_USE		    0x00000001L
#define M_REGARDLESS_INIT_FILE  0x00000002L
#define M_NO_BACKGROUND_MODE    0x00000004L
#define M_NOT_USE_TIME_STAMP    0x00000008L
#define M_EXTRACT_REPLACE_FILE  0x00000010L
#define M_EXTRACT_NEW_FILE      0x00000020L
#define M_EXTRACT_UPDATE_FILE   0x00000040L

#define M_CHECK_ALL_PATH        0x00000100L
#define M_CHECK_FILENAME_ONLY   0x00000200L
#define M_CHECK_DISK_SIZE       0x00000400L
#define M_REGARDLESS_DISK_SIZE  0x00000800L
#define M_USE_DRIVE_LETTER      0x00001000L
#define M_NOT_USE_DRIVE_LETTER  0x00002000L
#define M_INQUIRE_DIRECTORY     0x00004000L
#define M_NOT_INQUIRE_DIRECTORY 0x00008000L
#define M_INQUIRE_WRITE         0x00010000L
#define M_NOT_INQUIRE_WRITE     0x00020000L
#define M_CHECK_READONLY        0x00040000L
#define M_REGARDLESS_READONLY   0x00080000L
#define M_REGARD_E_COMMAND      0x00100000L
#define M_REGARD_X_COMMAND      0x00200000L
#define M_ERROR_MESSAGE_ON      0x00400000L
#define M_ERROR_MESSAGE_OFF     0x00800000L
#define M_BAR_WINDOW_ON         0x01000000L
#define M_BAR_WINDOW_OFF        0x02000000L
#define M_CHECK_PATH            0x04000000L
#define M_RECOVERY_ON           0x08000000L
#define M_MAKE_INDEX_FILE       0x10000000L
#define M_NOT_MAKE_INDEX_FILE   0x20000000L
#define EXTRACT_FOUND_FILE      0x40000000L
#define EXTRACT_NAMED_FILE      0x80000000L
#endif

//******************************************************************************
//    萔` (Ǝ)
//******************************************************************************

// R}hR[h
#define PAQ_LIST_COMMAND    1
#define PAQ_ADD_COMMAND     2
#define PAQ_FRESH_COMMAND   3
#define PAQ_DELETE_COMMAND  4
#define PAQ_EXTRACT_COMMAND 5
#define PAQ_PRINT_COMMAND   6
#define PAQ_TEST_COMMAND    7
#define PAQ_MAKESFX_COMMAND 8
#define PAQ_JOINT_COMMAND   9
#define PAQ_CONVERT_COMMAND 10
#define PAQ_RENAME_COMMAND  11

// k`R[h
#define ARCHIVETYPE_P5							0x000001
#define ARCHIVETYPE_P6							0x000002
#define ARCHIVETYPE_P12							0x000003

#define ARCHIVETYPE_PAQ1						0x001001
#define ARCHIVETYPE_PAQ1SSE						0x001002
#define ARCHIVETYPE_PAQ2						0x002001
#define ARCHIVETYPE_PAQ3						0x003001
#define ARCHIVETYPE_PAQ3N						0x003002
#define ARCHIVETYPE_PAQ4						0x004001
#define ARCHIVETYPE_PAQ4EMILCONT_DURITIUM		0x004011
#define ARCHIVETYPE_PAQ5						0x005001
#define ARCHIVETYPE_PAQ5EMILCONT_DEUTERIUM		0x005011

#define ARCHIVETYPE_PAQ6						0x006001
#define ARCHIVETYPE_PAQ6DS						0x006002
#define ARCHIVETYPE_PAQ6FB						0x006003
#define ARCHIVETYPE_PAQ6FDJ						0x006004
#define ARCHIVETYPE_PAQ6FDJ2					0x006005
#define ARCHIVETYPE_PAQ32						0x006006

#define ARCHIVETYPE_PAQ601						0x006007
#define ARCHIVETYPE_PAQ602						0x006008
#define ARCHIVETYPE_PAQ603						0x006009
#define ARCHIVETYPE_PAQ604						0x00600A
#define ARCHIVETYPE_PAQ605FB					0x00600B
#define ARCHIVETYPE_PAQ605FBJ					0x00600C
#define ARCHIVETYPE_PAQ6FBJ8					0x00600D
#define ARCHIVETYPE_PAQ6FBJ9					0x00600E
#define ARCHIVETYPE_PAQ606FB					0x00600F
#define ARCHIVETYPE_PAQ607FB					0x006010

#define ARCHIVETYPE_PAQ6_EMILCONT_JACKDAMARIOUM	0x006011
#define ARCHIVETYPE_PAQ6_EMILCONT_FEBAS			0x006012
#define ARCHIVETYPE_PAQ6_EMILCONT_ANNY			0x006013
#define ARCHIVETYPE_PAQ6_EMILCONT_ANNY607FB		0x006014
#define ARCHIVETYPE_PAQ6_EMILCONT_BLASTER		0x006015
#define ARCHIVETYPE_PAQ6EB						0x006016
#define ARCHIVETYPE_PAQ6EBB						0x006017
#define ARCHIVETYPE_PAQ6_EMILCONT_DESTROYER		0x006018
#define ARCHIVETYPE_PAQ6_EMILCONT_ANNYHILATOR	0x006019
#define ARCHIVETYPE_PAQ6_EMILCONT_HARLOCK		0x00601A
#define ARCHIVETYPE_PAQ6_EMILCONT_ITALIA		0x00601B
#define ARCHIVETYPE_PAQ6ED_SCHMIDT_A			0x00601C
#define ARCHIVETYPE_PAQ6ED_SCHMIDT_B			0x00601D

#define ARCHIVETYPE_PAQC						0x006021

#define ARCHIVETYPE_PAQ7						0x007001
#define ARCHIVETYPE_PAQ7STAR					0x007002
#define ARCHIVETYPE_PAQ7PLUS111					0x007003
#define ARCHIVETYPE_PAQ7PLUS119					0x007004

#define ARCHIVETYPE_PAQ8A						0x008001
#define ARCHIVETYPE_PAQ8A2						0x008001
#define ARCHIVETYPE_PAQ8B						0x008002
#define ARCHIVETYPE_PAQ8C						0x008003
#define ARCHIVETYPE_PAQ8D						0x008004
#define ARCHIVETYPE_PAQ8E						0x008005
#define ARCHIVETYPE_PAQ8F						0x008006
#define ARCHIVETYPE_PAQ8G						0x008007

#define ARCHIVETYPE_KGB10						0x100001
#define ARCHIVETYPE_KGB10_ENCRYPTED				0x100002

#define ARCHIVETYPE_PAQAR10						0x101001
#define ARCHIVETYPE_PAQAR11						0x101002
#define ARCHIVETYPE_PAQAR12						0x101003
#define ARCHIVETYPE_PAQAR13						0x101004
#define ARCHIVETYPE_PAQAR20						0x102001
#define ARCHIVETYPE_PAQAR30						0x103001
#define ARCHIVETYPE_PAQAR40						0x104001
#define ARCHIVETYPE_PAQAR45						0x104002

#define ARCHIVETYPE_PAQARCC45					0x104102

#define ARCHIVETYPE_AXPAQ20						0x202001

#define ARCHIVETYPE_UDA0213						0x302011
#define ARCHIVETYPE_UDA0215						0x302012
#define ARCHIVETYPE_UDA0220						0x302021
#define ARCHIVETYPE_UDA0220L					0x302022
#define ARCHIVETYPE_UDA0221L					0x302023
#define ARCHIVETYPE_UDA0230						0x302031
#define ARCHIVETYPE_UDA0231						0x302032
#define ARCHIVETYPE_UDA0240						0x302041
#define ARCHIVETYPE_UDA0250						0x302051
#define ARCHIVETYPE_UDA0260						0x302061
#define ARCHIVETYPE_UDA0270						0x302071
#define ARCHIVETYPE_UDA0271						0x302072
#define ARCHIVETYPE_UDA0280						0x302081
#define ARCHIVETYPE_UDA0281						0x302082
#define ARCHIVETYPE_UDA0283						0x302083
#define ARCHIVETYPE_UDA0284						0x302084
#define ARCHIVETYPE_UDA0290						0x302091
#define ARCHIVETYPE_UDA0291						0x302092

#define ARCHIVETYPE_EMILCONT01					0x401001
#define ARCHIVETYPE_EMILCONT02					0x402001
#define ARCHIVETYPE_EMILCONT02X					0x402002
#define ARCHIVETYPE_EMILCONT03					0x403001

#define ARCHIVETYPE_PASQDA10					0x501001
#define ARCHIVETYPE_PASQDA20					0x502001
#define ARCHIVETYPE_PASQDA21					0x502002
#define ARCHIVETYPE_PASQDA30					0x503001
#define ARCHIVETYPE_PASQDA39					0x503002
#define ARCHIVETYPE_PASQDA40					0x504001
#define ARCHIVETYPE_PASQDA41					0x504002
#define ARCHIVETYPE_PASQDA42					0x504003
#define ARCHIVETYPE_PASQDA43					0x504004
#define ARCHIVETYPE_PASQDA44					0x504005

#define ARCHIVETYPE_PASQDACC41					0x504101
#define ARCHIVETYPE_PASQDACC42					0x504102
#define ARCHIVETYPE_PASQDACC43					0x504103
#define ARCHIVETYPE_PASQDACC44					0x504104

// SFX R[h
#ifndef SFX_NOT
#define SFX_NOT					0

#define SFX_WIN32_KGB_10		00010

#define SFX_WIN32_UDA_0221L		12210
#define SFX_WIN32_UDA_0230		12300
#define SFX_WIN32_UDA_0230L		12301
#define SFX_WIN32_UDA_0231		12310
#define SFX_WIN32_UDA_0240		12400
#define SFX_WIN32_UDA_0241		12410
#define SFX_WIN32_UDA_0242		12420
#define SFX_WIN32_UDA_0250		12500
#define SFX_WIN32_UDA_0260		12600
#define SFX_WIN32_UDA_0261		12610

#define SFX_WIN32_UDA_0270		22700
#define SFX_WIN32_UDA_0271		22710
#define SFX_WIN32_UDA_0280		22800
#define SFX_WIN32_UDA_0281		22810
#define SFX_WIN32_UDA_0290		22900
#define SFX_WIN32_UDA_0291		22910

#define SFX_DOS_UNKNOWN			9901
#define SFX_WIN16_UNKNOWN		9911
#define SFX_WIN32_UNKNOWN		9921
#endif

#ifdef __cplusplus
extern "C"
{
#endif

//******************************************************************************
//    LHA.DLL ݊ API
//******************************************************************************

// Command : vȃR}hCs܂B
int WINAPI API_PREFIX(const HWND, LPCSTR, LPSTR, const DWORD);

// G API Q : ܂܂ȏ̎擾ƐݒB
WORD WINAPI API_NAME(GetVersion)(void);
WORD WINAPI API_NAME(GetSubVersion)(void);
WORD WINAPI API_NAME(GetBuild)(void);
BOOL WINAPI API_NAME(GetRunning)(void);
BOOL WINAPI API_NAME(GetBackGroundMode)(void);
BOOL WINAPI API_NAME(SetBackGroundMode)(const BOOL);
BOOL WINAPI API_NAME(GetCursorMode)(void);
BOOL WINAPI API_NAME(SetCursorMode)(const BOOL);
WORD WINAPI API_NAME(GetCursorInterval)(void);
BOOL WINAPI API_NAME(SetCursorInterval)(const WORD);

//******************************************************************************
//    LHA.DLL ݊ API
//******************************************************************************

// CheckArchive : ɂ̐B
BOOL WINAPI API_NAME(CheckArchive)(LPCSTR, const int);

// GetFileCount : ɂ̊i[t@C\B
int WINAPI API_NAME(GetFileCount)(LPCSTR);

// QueryFunctionList : API Ή̎擾B
BOOL WINAPI API_NAME(QueryFunctionList)(const int);

// ConfigDialog : ȈՐݒ_CAO̕\B
BOOL WINAPI API_NAME(ConfigDialog)(const HWND, LPSTR, const int);

/*
// ExtractMem : obt@֓WJB
int WINAPI API_NAME(ExtractMem)(const HWND, LPCSTR, LPBYTE, const DWORD, time_t *, LPWORD, LPDWORD);

// CompressMem : obt@֊i[B
int WINAPI API_NAME(CompressMem)(const HWND, LPCSTR, const LPBYTE, const DWORD, const time_t *, const LPWORD, LPDWORD);
*/

//******************************************************************************
//    OpenArchive n API (1) -  API Q
//******************************************************************************

// OpenArchive : Ƀnh擾B
HARC WINAPI API_NAME(OpenArchive)(const HWND, LPCSTR, const DWORD);

// OpenArchive2 : Ƀnh擾B
HARC WINAPI API_NAME(OpenArchive2)(const HWND, LPCSTR, const DWORD, LPCSTR);

// CloseArchive : ɃnhB
int WINAPI API_NAME(CloseArchive)(HARC);

// FindFirst : ŏ̃t@C擾B
int WINAPI API_NAME(FindFirst)(HARC, LPCSTR, INDIVIDUALINFO *);

// FindNext : 2 Ԗڈȍ~̃t@C擾B
int WINAPI API_NAME(FindNext)(HARC, INDIVIDUALINFO *);

/*
// Add : ɂɒǉB
int WINAPI API_NAME(Add)(HARC, LPCSTR, DWORD);

// Extract : ɂWJB
int WINAPI API_NAME(Extract)(HARC, LPCSTR, LPCSTR, DWORD);

// Move : ɂɈړB
int WINAPI API_NAME(Move)(HARC, LPCSTR, DWORD);

// Delete : ɂ폜B
int WINAPI API_NAME(Delete)(HARC, LPCSTR, DWORD);
*/

//******************************************************************************
//    OpenArchive n API (2) - ɏ擾 API Q
//******************************************************************************

// GetArcFileName : ɖ擾B
int WINAPI API_NAME(GetArcFileName)(HARC, LPSTR, const int);

// GetArcFileSize : ɃTCY擾B
DWORD WINAPI API_NAME(GetArcFileSize)(HARC);

// GetArcFileSizeEx : ɃTCY擾 (64Bit)B
BOOL WINAPI API_NAME(GetArcFileSizeEx)(HARC, LONGLONG *);

// GetArcOriginalSize : Kt@C̍v擾B
DWORD WINAPI API_NAME(GetArcOriginalSize)(HARC);

// GetArcOriginalSizeEx : Kt@C̍v擾 (64Bit)B
BOOL WINAPI API_NAME(GetArcOriginalSizeEx)(HARC, LONGLONG *);

// GetArcCompressedSize : Kt@C̈kTCY̍v擾B
DWORD WINAPI API_NAME(GetArcCompressedSize)(HARC);

// GetArcCompressedSizeEx : Kt@C̈kTCY̍v擾 (64Bit)B
BOOL WINAPI API_NAME(GetArcCompressedSizeEx)(HARC, LONGLONG *);

// GetArcRatio : Kt@C̑Ŝ̈k擾B
WORD WINAPI API_NAME(GetArcRatio)(HARC);

// GetArcDate : ɂ̓t擾B
WORD WINAPI API_NAME(GetArcDate)(HARC);

// GetArcTime : ɂ̎擾B
WORD WINAPI API_NAME(GetArcTime)(HARC);

// GetArcCreateTimeEx : ɂ̍쐬擾 (64Bit)B
BOOL WINAPI API_NAME(GetArcCreateTimeEx)(HARC, FILETIME *);

// GetArcAccessTimeEx : ɂ̎QƎ擾 (64Bit)B
BOOL WINAPI API_NAME(GetArcAccessTimeEx)(HARC, FILETIME *);

// GetArcWriteTimeEx : ɂ̍XV擾 (64Bit)B
BOOL WINAPI API_NAME(GetArcWriteTimeEx)(HARC, FILETIME *);

// GetArcOSType : ɂ̍쐬OS擾B
UINT WINAPI API_NAME(GetArcOSType)(HARC);

// IsSFXFile : ɂSFXW[̎ނ擾B
int WINAPI API_NAME(IsSFXFile)(HARC);

// GetArcReadSize : ɂ̓ǂݍݍς݃TCY̍v擾B
DWORD WINAPI API_NAME(GetArcReadSize)(HARC);

// GetArcReadSizeEx : ɂ̓ǂݍݍς݃TCY̍v擾 (64Bit)B
BOOL WINAPI API_NAME(GetArcReadSizeEx)(HARC, LONGLONG *);

//******************************************************************************
//    OpenArchive n API (3) - i[t@C擾 API Q
//******************************************************************************

// GetFileName : i[t@C擾B
int WINAPI API_NAME(GetFileName)(HARC, LPSTR, const int);

// GetMethod : i[t@C̊i[@擾B
int WINAPI API_NAME(GetMethod)(HARC, LPSTR, const int);

// GetOriginalSize : i[t@C̃t@CTCY擾B
DWORD WINAPI API_NAME(GetOriginalSize)(HARC);

// GetOriginalSizeEx : i[t@C̃t@CTCY擾 (64Bit)B
BOOL WINAPI API_NAME(GetOriginalSizeEx)(HARC, LONGLONG *);

// GetCompressedSize : i[t@C̈kTCY擾B
DWORD WINAPI API_NAME(GetCompressedSize)(HARC);

// GetCompressedSizeEx : i[t@C̈kTCY擾 (64Bit)B
BOOL WINAPI API_NAME(GetCompressedSizeEx)(HARC, LONGLONG *);

// GetRatio : i[t@C̈k擾B
WORD WINAPI API_NAME(GetRatio)(HARC);

// GetDate : i[t@C̓t擾B
WORD WINAPI API_NAME(GetDate)(HARC);

// GetTime : i[t@C̎擾B
WORD WINAPI API_NAME(GetTime)(HARC);

// GetCreateTime : i[t@C̍쐬擾B
DWORD WINAPI API_NAME(GetCreateTime)(HARC);

// GetCreateTimeEx : i[t@C̍쐬擾 (64Bit)B
BOOL WINAPI API_NAME(GetCreateTimeEx)(HARC, FILETIME *);

// GetWriteTime : i[t@C̍XV擾B
DWORD WINAPI API_NAME(GetWriteTime)(HARC);

// GetWriteTimeEx : i[t@C̍XV擾 (64Bit)B
BOOL WINAPI API_NAME(GetWriteTimeEx)(HARC, FILETIME *);

// GetAccessTime : i[t@C̎QƓ擾B
DWORD WINAPI API_NAME(GetAccessTime)(HARC);

// GetAccessTimeEx : i[t@C̎QƓ擾 (64Bit)B
BOOL WINAPI API_NAME(GetAccessTimeEx)(HARC,FILETIME *);

// GetCRC : i[t@C̃`FbNT擾B
DWORD WINAPI API_NAME(GetCRC)(HARC);

// GetAttribute : i[t@C̑擾B
int WINAPI API_NAME(GetAttribute)(HARC);

// GetAttributes : i[t@C̑擾B
int WINAPI API_NAME(GetAttributes)(HARC);

// GetOSType : i[t@C̍쐬OS擾B
UINT WINAPI API_NAME(GetOSType)(HARC);

//******************************************************************************
//    SetOwnerWindow n API
//******************************************************************************

// SetOwnerWindow : bZ[W̑MEChEݒB
BOOL WINAPI API_NAME(SetOwnerWindow)(HWND);

// ClearOwnerWindow : bZ[W̑MEChEݒB
BOOL WINAPI API_NAME(ClearOwnerWindow)(void);

// SetOwnerWindowEx : bZ[W̑MR[obN֐ݒ (32Bit)B
BOOL WINAPI API_NAME(SetOwnerWindowEx)(HWND, LPARCHIVERPROC);

// KillOwnerWindowEx : bZ[W̑MR[obN֐ (32Bit)B
BOOL WINAPI API_NAME(KillOwnerWindowEx)(HWND);

// SetOwnerWindowEx64 : bZ[W̑MR[obN֐ݒ (64Bit)B
BOOL WINAPI API_NAME(SetOwnerWindowEx64)(HWND, LPARCHIVERPROC, DWORD);

// KillOwnerWindowEx64 : bZ[W̑MR[obN֐ (64Bit)B
BOOL WINAPI API_NAME(KillOwnerWindowEx64)(HWND);

//******************************************************************************
//    SetEnumMembersProc n API
//******************************************************************************

// SetEnumMembersProc : R[obN֐ݒB
BOOL WINAPI API_NAME(SetEnumMembersProc)(PAQ_WND_ENUMMEMBPROC);

// ClearEnumMembersProc : R[obN֐B
BOOL WINAPI API_NAME(ClearEnumMembersProc)(void);

// SetEnumMembersProc64 : R[obN֐ݒ (64Bit)B
BOOL WINAPI API_NAME(SetEnumMembersProc64)(PAQ_WND_ENUMMEMBPROC, DWORD);

// ClearEnumMembersProc64 : R[obN֐ (64Bit)B
BOOL WINAPI API_NAME(ClearEnumMembersProc64)(void);


//******************************************************************************
//    SetLangueSpecified n API
//******************************************************************************

// SetLangueSpecified : \[X̌ݒB
void WINAPI SetLangueSpecified(LANGID);

// SetLangueJapanese : \[X̌{ɐݒB
void WINAPI SetLangueJapanese(void);

// SetLangueEnglish : \[X̌pɐݒB
void WINAPI SetLangueEnglish(void);

// SetLangueSpecified : \[X̌ݒB
void WINAPI API_NAME(SetLangueSpecified)(LANGID);

// SetLangueJapanese : \[X̌{ɐݒB
void WINAPI API_NAME(SetLangueJapanese)(void);

// SetLangueEnglish : \[X̌pɐݒB
void WINAPI API_NAME(SetLangueEnglish)(void);

//******************************************************************************
//    ̑API
//******************************************************************************

// SetPriority : Xbh̗D揇ʂݒB
BOOL WINAPI API_NAME(SetPriority)(int);

#ifdef __cplusplus
}
#endif

#endif
